
; ******************************************************************************
;
; $Header: /Z88/Applications/EazyLink/Defs.asm 1     31-05-98 10:21 Gbs $
;
; $History: Defs.asm $
; 
; *****************  Version 1  *****************
; User: Gbs          Date: 31-05-98   Time: 10:21
; Created in $/Z88/Applications/EazyLink
; Release 5.0.3:
; Popdown organised as "ugly popdown" with 1.5K contiguous RAM from $2000
; onwards. OS_TIN now used as keyboard interface. 
; New Server command implemented: ESC "M" - get free memory of RAM Card.
; 

; Application Safe workspace

; Variabel Address definitions...
; All variables are put into the Safe workspace (defined for both 'PClink' and 'MultiLink' to 1072 bytes)

; EazyLink commands identifiers in lookup tables
DEFC TotalOfCmds = 33

DEFC RAM_pages = 6				; allocate 6 * 256 bytes contigous memory from $2000...

DEFVARS $2000	   				; work space buffer for popdown...
{
    UserToggles		ds.b 1	; various user toggles
    Cpy_PA_Txb 		ds.b 3	; Length byte + 2 byte Txb baud rate
    Cpy_PA_Rxb 		ds.b 3	; Length byte + 2 byte Txb baud rate
    Cpy_PA_Xon 		ds.b 1	; Copy of current Xon/Xoff
    Cpy_PA_Par 		ds.b 1	; Copy of current parity i Panel
    MenuBarPosn		ds.b 1	; Y position of menu bar
    PopDownTimeout		ds.w 1	; x centiseconds to timeout and Screen Off...
    file_type			ds.b 1	; File type of current found file name in wildcard search
    tra_flag			ds.b 1	; Translate-bytes-flag, $FF when active.
    tra_flag_copy		ds.b 1
    CRLF_flag			ds.b 1	; $FF, when active
    buffer			ds.w 1	; Address of next free byte in buffer
    buflen			ds.b 1	; Current length of buffer
    serport_handle		ds.w 1	; Handle to serial port input.
    file_handle		ds.w 1	; Handle of opened file (read/write)
    wildcard_handle 	ds.w 1	; Handle of current wildcard search
    Filename_buffer 	ds.b 128	; Buffer for filenames
    File_buffer		ds.b 255	; Buffer for remote saving & loading of files
    TraTableIn 		ds.b 256	; ASCII translation lookup table, Z88
    TraTableOut		ds.b 256	; ASCII translation lookup table, External computer
    Creation_date		ds.b 6	; Temp store of a file's creation date
    Update_date		ds.b 6	; Temp store of a file's update date
    file_ptr			ds.l 1
    directory_ptr		ds.w 1
    DirName_stack		ds.b 128
}
